{{
Type or Dump a file to the screen demonstration for Kyedos
parameters passed in file COMMAND.TXT


}}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  _baudRateSpeed = 38400

  _receiverPin = 31
  _transmitterPin = 30


  _RTC_DAT = -1 ' -1 ifnot installed.
  _RTC_CLK = -1 ' -1 ifnot installed.

  _VGA_Enabled = true ' VGA display on
  _VGA_PinGroup = 2

  _LCD_Enabled = true ' false or true for 20x4 LCD display
  _Serial_Enabled = true ' send output to serial port 


  _SD_DO = 12
  _SD_CLK = 13
  _SD_DI = 14
  _SD_CS = 15
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
  
  Quote = 34
  Horizontal_Tab = 9
  Line_Feed = 10
  Carriage_Return =13

OBJ

  fat: "SD3.01_FATEngine.spin"
  taf: "SD3.01_FATEngine.spin"
  rtc: "DS1307_RTCEngine.spin"
  str: "ASCII0_STREngine.spin"
  VT100: "VGA_1024_VT100"       ' VGA VT100 Terminal Driver
  lcd : "DracLCD"                     ' 20x4 LCD driver for dracblade
  delay: "Timing"                     ' for millisecond delays
  sio     : "pcFullDuplexSerial2FC"
  key : "Pocketerm_Keyboard"           ' pocketerm keyboard 

VAR
   byte CommandLine[80] ' complete command line as typed in
   byte LineOfText1[80] ' general purpose string buffer
   byte LineOfText2[80] ' general purpose string buffer
   byte LineOfText3[80] ' general purpose string buffer

PUB shell | i

  VT100.start(16)                                       ' start the vga driver VGA starts on pin 16
  VT100.startcursor                                     ' start the cursor
  VT100.color(%00001000_11111100)                       ' Blue_White  blue =3/4 power 10, white =full                                  
  VT100.cursorset(5)                                    ' cursor type 5
  VT100.clearscreen                                     ' clear the screen
  sio.AddPort(0, _receiverPin, _transmitterPin, -1, -1, 0, 0, _baudRateSpeed)
  key.startx(26, 27, %100, 40)             'Start Keyboard Driver  pin,pin,num,repeatrate    
  if(_LCD_Enabled)
    lcd.start ' start the LCD display
  ifnot( fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, _RTC_DAT, _RTC_CLK, -1))
    reboot
  sio.start             ' start the com port  note can't print anything to screen till sio.start unless only do to vga screen
  sio.rxflush(0)                                        ' in case try to send an xmodem transfer 
  PrintStringCR(string("Type/Dump a file"))  ' helpful message if card is out, better than just a blank screen
  fat.mountPartition(0)     ' mount the sd card
  ifnot(fat.partitionMounted)
    printstring(string("Card Not Mounted "))   
  result := \fat.openfile(string("COMMAND.TXT"),"R")
  result := \fat.readstring(@commandline,80)            ' read in the command line
  result := \fat.closefile
  i := str.len(@commandline)                            ' length of the string "TYPE MYFILE.TXT"
  str.mid(@commandline,@lineoftext1,6,i-5)              ' get the filename
  result := \fat.openfile(@lineoftext1,"R")             ' open it
  repeat 
    result := \fat.readbyte                             ' read to the end
    printchar(result)
  until result == 0  
  result := \fat.closefile                              ' close the file
  
  crlf
  printstring(string("Hit any key to continue:"))       ' wait for a keypress
  result := 0
  repeat
        if key.gotkey <>0        ' scan both the local keyboard and the com port
          result := key.getkey
        if sio.rxavail(0)
          result :=sio.rx(0)  
  until result <> 0           ' until something comes in either port
                                       
  reboot ' back to Kyedos

PUB PrintStringCR(pstring)' sends pstring to the vga and serial port
     PrintString(pstring)                               ' print the string  
     crlf

PUB PrintString(pstring)' sends pstring to the vga and serial port with no CRLF
    if (_VGA_Enabled)  
      vt100.str(pstring)                                 ' send to vga screen
    if (_Serial_Enabled)   
    sio.str(0,pstring)                                 ' send to com port
    if (_lcd_Enabled)
       lcd.str(pstring)                                   ' send to 20x4 lCD display

PUB PrintChar(c) ' sends c to vga and serial port
    if (_VGA_Enabled)
      vt100.out(c)                                        ' send to vga
    if (_Serial_Enabled)
      sio.tx(0,c)                                         ' send to com port
    if (_lcd_Enabled)
      LCD.out(c)                                          ' send to LCD display      
PUB CRLF
    PrintChar(13)                                        ' send to vga
    PrintChar(10)                                        ' send to vga

PUB PrintDecimal(number)                                ' print the decimal value, useful for debuggin
     PrintString(str.integerToDecimal(number, 10))   
        
{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}